﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace WpfApplication1
{
    public class BusinessObject
    {
        public BusinessObject()
        {

        }

        string name = string.Empty;
        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        ObservableCollection<BusinessObject> childList = null;
        public ObservableCollection<BusinessObject> ChildList
        {
            get
            {
                if (childList == null)
                    childList = new ObservableCollection<BusinessObject>();
                return childList;
            }
            set { childList = value; }
        }

        string info1 = string.Empty;
        public string Info1
        {
            get { return info1; }
            set { info1 = value; }
        }

        string info2 = string.Empty;
        public string Info2
        {
            get { return info2; }
            set { info2 = value; }
        }

        string info3 = string.Empty;
        public string Info3
        {
            get { return info3; }
            set { info3 = value; }
        }

        int info4 = 0;
        public int Info4
        {
            get { return info4; }
            set { info4 = value; }
        }

        int info5 = 0;
        public int Info5
        {
            get { return info5; }
            set { info5 = value; }
        }

        int info6 = 0;
        public int Info6
        {
            get { return info6; }
            set { info6 = value; }
        }

        public static BusinessObject GetSampleObject(Random r, int i)
        {
            return new BusinessObject()
            {
                Name = string.Format("Name{0}", i),
                Info1 = string.Format("Info1_{0}", r.Next(100)),
                Info2 = string.Format("Info2_{0}", r.Next(100)),
                Info3 = string.Format("Info3_{0}", r.Next(100)),
                Info4 = r.Next(100),
                Info5 = r.Next(100),
                Info6 = i
            };
        }
        public static ObservableCollection<BusinessObject> GetList()
        {
            int totalCount = 1000;
            int topLevelCount = 50;
            var list = new ObservableCollection<BusinessObject>();
            var temp = new List<BusinessObject>();
            var r = new Random(123121);

            for (int i = 0; i < totalCount; ++i)
            {
                var bo = GetSampleObject(r, i);
                temp.Add(bo);

                if (i >= topLevelCount)
                {
                    var parent = temp[r.Next(i - 1)];
                    if (parent.ChildList == null)
                    {
                        parent.ChildList = new ObservableCollection<BusinessObject>();
                    }
                    parent.ChildList.Add(bo);
                }
                else
                {
                    list.Add(bo);
                }
            }

            return list;
        }


       
    }
}
